'*********************************************************
' Apprendre la programmation des PIC II                  *
' Projet N 3                                            *
' Exemple de gestion d'un moteur en PWM                  *
' Pic utilis : 18 F 4520                                *
' Quartz : 4 Mhz                                         *
' Version 1.0 du 20 mars 2011                            *
' Auteur PM                                              *
'*********************************************************


'************ Directives **************
	
    Device 18F4520           ' Pic utilis
    XTAL = 4
    Declare serial_data 8  
    Symbol T9600 = 84	NO_LIST
      
'************ Variables **************

    Dim donnee As Byte      ' donne reue sur LS 
    Dim donnee_ana As Word  ' donnee du CNA
    Dim tableau[2] As Byte  ' tableau o seront stocks les octets issus de la LS
    Dim marche As Bit       ' variable utilise pour mise en service
    
'************ Symboles utiliss **************

    Symbol led =PORTC.0         ' la led est connecte sur la broche 0 du Port C (RC0)
    
'******* Initialisation *******

    'init registre E/S
    TRISC=%10000000        ' le Port C est dclar en sortie sauf RC7 en entre (RX LS)

    'init variables
    marche = 0
    Low led                ' Extinction de la led

    'init mode pwm
    CCP1CON = %00001100    ' mode pwm
    T2CON = %01111111      ' Timer 2 en service (prescale = 16 postcale=16)
    PR2=128                ' rglage de PR2 pour xxx Hz en sortie       
   	CCP1CON.4 = 0          ' init ccp1con 
    CCP1CON.5 = 0          ' init ccp1con
    CCPR1L = 0             ' init ccpr1l    	                

                
debut:

   'Attente d'un caractre 'n' sur la liaison srie
   SerIn PORTC.7 , T9600 ,1000,fin, [Wait (110), Str tableau]                
           
   donnee=   tableau[0]
   If donnee = 80 Then pwm_                          'commande chgt rapport cyclique PWM (P)
   If donnee = 70 Then freq                          'commande chgt frquence PWM (F)
   
   If donnee = 77 And tableau[1]= 49 Then marche = 1 'bouton marche appuy (M)
   If donnee = 77 And tableau[1]= 48 Then marche = 0 'bouton marche appuy (M)

   If marche =0 Then GoTo fin                        'si variable marche =0
   GoTo debut

pwm_:
   
   If marche =0 Then GoTo fin
   CCPR1L =  tableau[1]             	                     
   DelayMS 500                                                      'temporisation de 100 mS 

    ADCON1=%00000111                    'voies An0-AN7 actives 
    donnee_ana=0
    ADCON2=%10100010                    'TAD = 8 Fosc/32 (voir registre ADCON2)

'********* Voie AN0 **********

   ADCON0=%00000001                     'config registre ADCON0 (Alim + slection voie AN0)
   DelayMS 100                          'temporisation de 100 mS 
   ADCON0.1 = 1                         'lancement de la conversion (bit 1 de ADCON0)

Loop:
       If ADCON0.1=1 Then GoTo Loop                     'test si la conversion est termine (bit 2 =0)
       donnee_ana=ADRESL                                'transfre 8 bits poids faible du rsultat dans donnee_ana
       donnee_ana.8 = ADRESH.0                          'transfre 9eme bit (ADRESH) du rsultat dans donnee_ana
       donnee_ana.9=ADRESH.1                            'transfre 10eme bit (ADRESH) du rsultat dans donnee_ana          
       SerOut PORTC.6,T9600,["Retour tension : ", Dec  donnee_ana ]              'on transfre ADRESH- ADRESL sur la LS       
       SerOut PORTC.6,T9600,["  Valeur tension : ", Dec  donnee_ana * 0.0048," V" ]  'on transfre la valeur sur la LS       
       GoTo fin

freq:
   
       If marche =0 Then GoTo fin
       PR2 =  tableau[1]             	                     
       DelayMS 100                         'temporisation de 100 mS 
       ADCON1=%00000111                    'voies An0-AN7 actives 
       donnee_ana=0
       ADCON2=%10100010                    'TAD = 8 Fosc/32 (voir registre ADCON2)
Loop2:
       If ADCON0.1=1 Then GoTo Loop2                     'test si la conversion est termine (bit 2 =0)
       donnee_ana=ADRESL                                'transfre 8 bits poids faible du rsultat dans donnee_ana
       donnee_ana.8 = ADRESH.0                          'transfre 9eme bit (ADRESH) du rsultat dans donnee_ana
       donnee_ana.9=ADRESH.1                            'transfre 10eme bit (ADRESH) du rsultat dans donnee_ana          
       SerOut PORTC.6,T9600,["Retour tension : ", Dec  donnee_ana ]              'on transfre ADRESH- ADRESL sur la LS       
       SerOut PORTC.6,T9600,["  Valeur tension : ", Dec  donnee_ana * 0.0048," V" ]  'on transfre la valeur sur la LS       
   GoTo fin   
 
fin:
        If marche = 1 Then 
            Toggle led           'inversion de l'tat de la led
        Else
            Low led
            CCPR1L = 0
        End If             
        GoTo debut               'retour au dbut du programme

        End                      'fin du programme



